Index: uspace/lib/gfxfont/test/text.c
===================================================================
--- uspace/lib/gfxfont/test/text.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/gfxfont/test/text.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -30,5 +30,4 @@
 #include <gfx/context.h>
 #include <gfx/font.h>
-#include <gfx/glyph.h>
 #include <gfx/text.h>
 #include <gfx/typeface.h>
@@ -141,302 +140,4 @@
 	rc = gfx_puttext(font, &pos, &fmt, "Hello world!");
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	gfx_font_close(font);
-	gfx_typeface_destroy(tface);
-	gfx_color_delete(color);
-
-	rc = gfx_context_delete(gc);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-}
-
-/** gfx_text_start_pos() correctly computes text start position */
-PCUT_TEST(text_start_pos)
-{
-	gfx_font_props_t props;
-	gfx_font_metrics_t metrics;
-	gfx_typeface_t *tface;
-	gfx_font_t *font;
-	gfx_context_t *gc;
-	gfx_color_t *color;
-	gfx_text_fmt_t fmt;
-	gfx_coord2_t pos;
-	test_gc_t tgc;
-	errno_t rc;
-
-	rc = gfx_context_new(&test_ops, (void *)&tgc, &gc);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	rc = gfx_color_new_rgb_i16(0, 0, 0, &color);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	rc = gfx_typeface_create(gc, &tface);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	gfx_font_props_init(&props);
-	gfx_font_metrics_init(&metrics);
-	metrics.ascent = 10; // XXX
-	metrics.descent = 10; // XXX
-	rc = gfx_font_create(tface, &props, &metrics, &font);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	gfx_text_fmt_init(&fmt);
-	fmt.color = color;
-	pos.x = 0;
-	pos.y = 0;
-
-	rc = gfx_puttext(font, &pos, &fmt, "Hello world!");
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	gfx_font_close(font);
-	gfx_typeface_destroy(tface);
-	gfx_color_delete(color);
-
-	rc = gfx_context_delete(gc);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-}
-
-/** gfx_text_find_pos() finds position in text */
-PCUT_TEST(text_find_pos)
-{
-	gfx_font_props_t props;
-	gfx_font_metrics_t metrics;
-	gfx_typeface_t *tface;
-	gfx_font_t *font;
-	gfx_glyph_metrics_t gmetrics;
-	gfx_glyph_t *glyph1;
-	gfx_glyph_t *glyph2;
-	gfx_context_t *gc;
-	gfx_text_fmt_t fmt;
-	gfx_coord2_t anchor;
-	gfx_coord2_t fpos;
-	size_t off;
-	test_gc_t tgc;
-	errno_t rc;
-
-	rc = gfx_context_new(&test_ops, (void *)&tgc, &gc);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	rc = gfx_typeface_create(gc, &tface);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	gfx_font_props_init(&props);
-	gfx_font_metrics_init(&metrics);
-	rc = gfx_font_create(tface, &props, &metrics, &font);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	/* Need to create some glyphs with metrics */
-	gfx_glyph_metrics_init(&gmetrics);
-	gmetrics.advance = 10;
-
-	rc = gfx_glyph_create(font, &gmetrics, &glyph1);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	rc = gfx_glyph_set_pattern(glyph1, "A");
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	gfx_glyph_metrics_init(&gmetrics);
-	gmetrics.advance = 1;
-
-	rc = gfx_glyph_create(font, &gmetrics, &glyph2);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	rc = gfx_glyph_set_pattern(glyph2, "i");
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	gfx_text_fmt_init(&fmt);
-	anchor.x = 10;
-	anchor.y = 0;
-
-	fpos.x = 9;
-	fpos.y = 0;
-	off = gfx_text_find_pos(font, &anchor, &fmt, "Aii", &fpos);
-	PCUT_ASSERT_INT_EQUALS(0, off);
-
-	fpos.x = 10;
-	fpos.y = 0;
-	off = gfx_text_find_pos(font, &anchor, &fmt, "Aii", &fpos);
-	PCUT_ASSERT_INT_EQUALS(0, off);
-
-	fpos.x = 11;
-	fpos.y = 0;
-	off = gfx_text_find_pos(font, &anchor, &fmt, "Aii", &fpos);
-	PCUT_ASSERT_INT_EQUALS(0, off);
-
-	fpos.x = 19;
-	fpos.y = 0;
-	off = gfx_text_find_pos(font, &anchor, &fmt, "Aii", &fpos);
-	PCUT_ASSERT_INT_EQUALS(1, off);
-
-	fpos.x = 20;
-	fpos.y = 0;
-	off = gfx_text_find_pos(font, &anchor, &fmt, "Aii", &fpos);
-	PCUT_ASSERT_INT_EQUALS(2, off);
-
-	fpos.x = 21;
-	fpos.y = 0;
-	off = gfx_text_find_pos(font, &anchor, &fmt, "Aii", &fpos);
-	PCUT_ASSERT_INT_EQUALS(3, off);
-
-	fpos.x = 22;
-	fpos.y = 0;
-	off = gfx_text_find_pos(font, &anchor, &fmt, "Aii", &fpos);
-	PCUT_ASSERT_INT_EQUALS(3, off);
-
-	gfx_glyph_destroy(glyph1);
-	gfx_glyph_destroy(glyph2);
-
-	gfx_font_close(font);
-	gfx_typeface_destroy(tface);
-
-	rc = gfx_context_delete(gc);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-}
-
-/** gfx_text_find_pos() finds position in text in text mode */
-PCUT_TEST(text_find_pos_text)
-{
-	gfx_typeface_t *tface;
-	gfx_font_t *font;
-	gfx_context_t *gc;
-	test_gc_t tgc;
-	size_t off;
-	gfx_text_fmt_t fmt;
-	gfx_coord2_t anchor;
-	gfx_coord2_t fpos;
-	errno_t rc;
-
-	rc = gfx_context_new(&test_ops, (void *)&tgc, &gc);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	rc = gfx_typeface_create(gc, &tface);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	rc = gfx_font_create_textmode(tface, &font);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	anchor.x = 10;
-	anchor.y = 0;
-	gfx_text_fmt_init(&fmt);
-
-	fpos.x = 9;
-	fpos.y = 0;
-	off = gfx_text_find_pos(font, &anchor, &fmt, "Abc", &fpos);
-	PCUT_ASSERT_INT_EQUALS(0, off);
-
-	fpos.x = 10;
-	fpos.y = 0;
-	off = gfx_text_find_pos(font, &anchor, &fmt, "Abc", &fpos);
-	PCUT_ASSERT_INT_EQUALS(0, off);
-
-	fpos.x = 11;
-	fpos.y = 0;
-	off = gfx_text_find_pos(font, &anchor, &fmt, "Abc", &fpos);
-	PCUT_ASSERT_INT_EQUALS(1, off);
-
-	fpos.x = 12;
-	fpos.y = 0;
-	off = gfx_text_find_pos(font, &anchor, &fmt, "Abc", &fpos);
-	PCUT_ASSERT_INT_EQUALS(2, off);
-
-	fpos.x = 13;
-	fpos.y = 0;
-	off = gfx_text_find_pos(font, &anchor, &fmt, "Abc", &fpos);
-	PCUT_ASSERT_INT_EQUALS(3, off);
-
-	fpos.x = 14;
-	fpos.y = 0;
-	off = gfx_text_find_pos(font, &anchor, &fmt, "Abc", &fpos);
-	PCUT_ASSERT_INT_EQUALS(3, off);
-
-	gfx_font_close(font);
-	gfx_typeface_destroy(tface);
-
-	rc = gfx_context_delete(gc);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-}
-
-/** gfx_text_cont() produces correct continuation parameters */
-PCUT_TEST(text_cont)
-{
-	gfx_typeface_t *tface;
-	gfx_font_t *font;
-	gfx_context_t *gc;
-	gfx_color_t *color;
-	test_gc_t tgc;
-	gfx_text_fmt_t fmt;
-	gfx_coord2_t anchor;
-	gfx_coord2_t cpos;
-	gfx_text_fmt_t cfmt;
-	errno_t rc;
-
-	rc = gfx_context_new(&test_ops, (void *)&tgc, &gc);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	rc = gfx_typeface_create(gc, &tface);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	rc = gfx_font_create_textmode(tface, &font);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	rc = gfx_color_new_rgb_i16(0, 0, 0, &color);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	anchor.x = 10;
-	anchor.y = 20;
-	gfx_text_fmt_init(&fmt);
-	fmt.color = color;
-
-	gfx_text_cont(font, &anchor, &fmt, "Abc", &cpos, &cfmt);
-
-	PCUT_ASSERT_INT_EQUALS(13, cpos.x);
-	PCUT_ASSERT_INT_EQUALS(20, cpos.y);
-	PCUT_ASSERT_EQUALS(fmt.color, cfmt.color);
-	PCUT_ASSERT_EQUALS(gfx_halign_left, cfmt.halign);
-	PCUT_ASSERT_EQUALS(gfx_valign_baseline, cfmt.valign);
-
-	gfx_font_close(font);
-	gfx_typeface_destroy(tface);
-	gfx_color_delete(color);
-
-	rc = gfx_context_delete(gc);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-}
-
-/** gfx_text_rect() computes bounding rectangle */
-PCUT_TEST(text_rect)
-{
-	gfx_typeface_t *tface;
-	gfx_font_t *font;
-	gfx_context_t *gc;
-	gfx_color_t *color;
-	test_gc_t tgc;
-	gfx_text_fmt_t fmt;
-	gfx_coord2_t anchor;
-	gfx_rect_t rect;
-	errno_t rc;
-
-	rc = gfx_context_new(&test_ops, (void *)&tgc, &gc);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	rc = gfx_typeface_create(gc, &tface);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	rc = gfx_font_create_textmode(tface, &font);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	rc = gfx_color_new_rgb_i16(0, 0, 0, &color);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	anchor.x = 10;
-	anchor.y = 20;
-	gfx_text_fmt_init(&fmt);
-	fmt.color = color;
-
-	gfx_text_rect(font, &anchor, &fmt, "Abc", &rect);
-
-	PCUT_ASSERT_INT_EQUALS(10, rect.p0.x);
-	PCUT_ASSERT_INT_EQUALS(20, rect.p0.y);
-	PCUT_ASSERT_INT_EQUALS(13, rect.p1.x);
-	PCUT_ASSERT_INT_EQUALS(21, rect.p1.y);
 
 	gfx_font_close(font);
Index: uspace/lib/inet/include/inet/addr.h
===================================================================
--- uspace/lib/inet/include/inet/addr.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/include/inet/addr.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2013 Jiri Svoboda
  * All rights reserved.
  *
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libinet
+/** @addtogroup libc
  * @{
  */
@@ -33,13 +33,12 @@
  */
 
-#ifndef LIBINET_INET_ADDR_H
-#define LIBINET_INET_ADDR_H
+#ifndef _LIBC_INET_ADDR_H_
+#define _LIBC_INET_ADDR_H_
 
 #include <errno.h>
-#include <inet/eth_addr.h>
 #include <stdint.h>
 
 typedef uint32_t addr32_t;
-
+typedef uint8_t addr48_t[6];
 typedef uint8_t addr128_t[16];
 
@@ -79,9 +78,13 @@
 
 extern const addr32_t addr32_broadcast_all_hosts;
+extern const addr48_t addr48_broadcast;
 
+extern void addr48(const addr48_t, addr48_t);
 extern void addr128(const addr128_t, addr128_t);
 
+extern int addr48_compare(const addr48_t, const addr48_t);
 extern int addr128_compare(const addr128_t, const addr128_t);
-extern void eth_addr_solicited_node(const addr128_t, eth_addr_t *);
+
+extern void addr48_solicited_node(const addr128_t, addr48_t);
 
 extern void host2addr128_t_be(const addr128_t, addr128_t);
Index: uspace/lib/inet/include/inet/dhcp.h
===================================================================
--- uspace/lib/inet/include/inet/dhcp.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/include/inet/dhcp.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libinet
+/** @addtogroup libc
  * @{
  */
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBINET_INET_DHCP_H
-#define LIBINET_INET_DHCP_H
+#ifndef _LIBC_INET_DHCP_H_
+#define _LIBC_INET_DHCP_H_
 
 #include <types/common.h>
Index: uspace/lib/inet/include/inet/dnsr.h
===================================================================
--- uspace/lib/inet/include/inet/dnsr.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/include/inet/dnsr.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libinet
+/** @addtogroup libc
  * @{
  */
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBINET_INET_DNSR_H
-#define LIBINET_INET_DNSR_H
+#ifndef _LIBC_INET_DNSR_H_
+#define _LIBC_INET_DNSR_H_
 
 #include <inet/inet.h>
Index: uspace/lib/inet/include/inet/endpoint.h
===================================================================
--- uspace/lib/inet/include/inet/endpoint.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/include/inet/endpoint.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libinet
+/** @addtogroup libc
  * @{
  */
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBINET_INET_ENDPOINT_H
-#define LIBINET_INET_ENDPOINT_H
+#ifndef _LIBC_INET_ENDPOINT_H_
+#define _LIBC_INET_ENDPOINT_H_
 
 #include <stdint.h>
Index: uspace/lib/inet/include/inet/host.h
===================================================================
--- uspace/lib/inet/include/inet/host.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/include/inet/host.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libinet
+/** @addtogroup libc
  * @{
  */
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBINET_INET_HOST_H
-#define LIBINET_INET_HOST_H
+#ifndef _LIBC_INET_HOST_H_
+#define _LIBC_INET_HOST_H_
 
 #include <inet/addr.h>
Index: uspace/lib/inet/include/inet/hostname.h
===================================================================
--- uspace/lib/inet/include/inet/hostname.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/include/inet/hostname.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libinet
+/** @addtogroup libc
  * @{
  */
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBINET_INET_HOSTNAME_H
-#define LIBINET_INET_HOSTNAME_H
+#ifndef _LIBC_INET_HOSTNAME_H_
+#define _LIBC_INET_HOSTNAME_H_
 
 extern errno_t inet_hostname_parse(const char *, char **, char **);
Index: uspace/lib/inet/include/inet/hostport.h
===================================================================
--- uspace/lib/inet/include/inet/hostport.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/include/inet/hostport.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libinet
+/** @addtogroup libc
  * @{
  */
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBINET_INET_HOSTPORT_H
-#define LIBINET_INET_HOSTPORT_H
+#ifndef _LIBC_INET_HOSTPORT_H_
+#define _LIBC_INET_HOSTPORT_H_
 
 #include <inet/addr.h>
Index: uspace/lib/inet/include/inet/inet.h
===================================================================
--- uspace/lib/inet/include/inet/inet.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/include/inet/inet.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libinet
+/** @addtogroup libc
  * @{
  */
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBINET_INET_INET_H
-#define LIBINET_INET_INET_H
+#ifndef _LIBC_INET_INET_H_
+#define _LIBC_INET_INET_H_
 
 #include <inet/addr.h>
Index: uspace/lib/inet/include/inet/inetcfg.h
===================================================================
--- uspace/lib/inet/include/inet/inetcfg.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/include/inet/inetcfg.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libinet
+/** @addtogroup libc
  * @{
  */
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBINET_INET_INETCFG_H
-#define LIBINET_INET_INETCFG_H
+#ifndef _LIBC_INET_INETCFG_H_
+#define _LIBC_INET_INETCFG_H_
 
 #include <inet/inet.h>
Index: uspace/lib/inet/include/inet/inetping.h
===================================================================
--- uspace/lib/inet/include/inet/inetping.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/include/inet/inetping.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libinet
+/** @addtogroup libc
  * @{
  */
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBINET_INET_INETPING_H
-#define LIBINET_INET_INETPING_H
+#ifndef _LIBC_INET_INETPING_H_
+#define _LIBC_INET_INETPING_H_
 
 #include <inet/inet.h>
Index: uspace/lib/inet/include/inet/iplink.h
===================================================================
--- uspace/lib/inet/include/inet/iplink.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/include/inet/iplink.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2012 Jiri Svoboda
  * All rights reserved.
  *
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libinet
+/** @addtogroup libc
  * @{
  */
@@ -33,10 +33,9 @@
  */
 
-#ifndef LIBINET_INET_IPLINK_H
-#define LIBINET_INET_IPLINK_H
+#ifndef _LIBC_INET_IPLINK_H_
+#define _LIBC_INET_IPLINK_H_
 
 #include <async.h>
 #include <inet/addr.h>
-#include <inet/eth_addr.h>
 
 struct iplink_ev_ops;
@@ -63,5 +62,5 @@
 typedef struct {
 	/** Local MAC destination address */
-	eth_addr_t dest;
+	addr48_t dest;
 	/** Serialized IP packet */
 	void *data;
@@ -80,5 +79,5 @@
 typedef struct iplink_ev_ops {
 	errno_t (*recv)(iplink_t *, iplink_recv_sdu_t *, ip_ver_t);
-	errno_t (*change_addr)(iplink_t *, eth_addr_t *);
+	errno_t (*change_addr)(iplink_t *, addr48_t);
 } iplink_ev_ops_t;
 
@@ -90,6 +89,6 @@
 extern errno_t iplink_addr_remove(iplink_t *, inet_addr_t *);
 extern errno_t iplink_get_mtu(iplink_t *, size_t *);
-extern errno_t iplink_get_mac48(iplink_t *, eth_addr_t *);
-extern errno_t iplink_set_mac48(iplink_t *, eth_addr_t *);
+extern errno_t iplink_get_mac48(iplink_t *, addr48_t *);
+extern errno_t iplink_set_mac48(iplink_t *, addr48_t);
 extern void *iplink_get_userptr(iplink_t *);
 
Index: uspace/lib/inet/include/inet/iplink_srv.h
===================================================================
--- uspace/lib/inet/include/inet/iplink_srv.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/include/inet/iplink_srv.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2012 Jiri Svoboda
  * All rights reserved.
  *
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libinet
+/** @addtogroup libc
  * @{
  */
@@ -33,13 +33,12 @@
  */
 
-#ifndef LIBINET_INET_IPLINK_SRV_H
-#define LIBINET_INET_IPLINK_SRV_H
+#ifndef _LIBC_INET_IPLINK_SRV_H_
+#define _LIBC_INET_IPLINK_SRV_H_
 
 #include <async.h>
 #include <fibril_synch.h>
+#include <stdbool.h>
 #include <inet/addr.h>
-#include <inet/eth_addr.h>
 #include <inet/iplink.h>
-#include <stdbool.h>
 
 struct iplink_ops;
@@ -59,6 +58,6 @@
 	errno_t (*send6)(iplink_srv_t *, iplink_sdu6_t *);
 	errno_t (*get_mtu)(iplink_srv_t *, size_t *);
-	errno_t (*get_mac48)(iplink_srv_t *, eth_addr_t *);
-	errno_t (*set_mac48)(iplink_srv_t *, eth_addr_t *);
+	errno_t (*get_mac48)(iplink_srv_t *, addr48_t *);
+	errno_t (*set_mac48)(iplink_srv_t *, addr48_t *);
 	errno_t (*addr_add)(iplink_srv_t *, inet_addr_t *);
 	errno_t (*addr_remove)(iplink_srv_t *, inet_addr_t *);
@@ -69,5 +68,5 @@
 extern errno_t iplink_conn(ipc_call_t *, void *);
 extern errno_t iplink_ev_recv(iplink_srv_t *, iplink_recv_sdu_t *, ip_ver_t);
-extern errno_t iplink_ev_change_addr(iplink_srv_t *, eth_addr_t *);
+extern errno_t iplink_ev_change_addr(iplink_srv_t *, addr48_t *);
 
 #endif
Index: uspace/lib/inet/include/inet/tcp.h
===================================================================
--- uspace/lib/inet/include/inet/tcp.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/include/inet/tcp.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libinet
+/** @addtogroup libc
  * @{
  */
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBINET_INET_TCP_H
-#define LIBINET_INET_TCP_H
+#ifndef _LIBC_INET_TCP_H_
+#define _LIBC_INET_TCP_H_
 
 #include <fibril_synch.h>
Index: uspace/lib/inet/include/inet/udp.h
===================================================================
--- uspace/lib/inet/include/inet/udp.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/include/inet/udp.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libinet
+/** @addtogroup libc
  * @{
  */
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBINET_INET_UDP_H
-#define LIBINET_INET_UDP_H
+#ifndef _LIBC_INET_UDP_H_
+#define _LIBC_INET_UDP_H_
 
 #include <async.h>
Index: uspace/lib/inet/include/ipc/dhcp.h
===================================================================
--- uspace/lib/inet/include/ipc/dhcp.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/include/ipc/dhcp.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libinet
+/** @addtogroup libcipc
  * @{
  */
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBINET_IPC_DHCP_H
-#define LIBINET_IPC_DHCP_H
+#ifndef _LIBC_IPC_DHCP_H_
+#define _LIBC_IPC_DHCP_H_
 
 #include <ipc/common.h>
Index: uspace/lib/inet/include/ipc/dnsr.h
===================================================================
--- uspace/lib/inet/include/ipc/dnsr.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/include/ipc/dnsr.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,10 +27,10 @@
  */
 
-/** @addtogroup libinet
+/** @addtogroup libcipc
  * @{
  */
 
-#ifndef LIBINET_IPC_DNSR_H
-#define LIBINET_IPC_DNSR_H
+#ifndef _LIBC_IPC_DNSR_H_
+#define _LIBC_IPC_DNSR_H_
 
 #include <ipc/common.h>
Index: uspace/lib/inet/include/ipc/inet.h
===================================================================
--- uspace/lib/inet/include/ipc/inet.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/include/ipc/inet.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libinet
+/** @addtogroup libcipc
  * @{
  */
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBINET_IPC_INET_H
-#define LIBINET_IPC_INET_H
+#ifndef _LIBC_IPC_INET_H_
+#define _LIBC_IPC_INET_H_
 
 #include <ipc/common.h>
Index: uspace/lib/inet/include/ipc/iplink.h
===================================================================
--- uspace/lib/inet/include/ipc/iplink.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/include/ipc/iplink.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libinet
+/** @addtogroup libcipc
  * @{
  */
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBINET_IPC_IPLINK_H
-#define LIBINET_IPC_IPLINK_H
+#ifndef _LIBC_IPC_IPLINK_H_
+#define _LIBC_IPC_IPLINK_H_
 
 #include <ipc/common.h>
Index: uspace/lib/inet/include/ipc/tcp.h
===================================================================
--- uspace/lib/inet/include/ipc/tcp.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/include/ipc/tcp.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libinet
+/** @addtogroup libcipc
  * @{
  */
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBINET_IPC_TCP_H
-#define LIBINET_IPC_TCP_H
+#ifndef _LIBC_IPC_TCP_H_
+#define _LIBC_IPC_TCP_H_
 
 #include <ipc/common.h>
Index: uspace/lib/inet/include/ipc/udp.h
===================================================================
--- uspace/lib/inet/include/ipc/udp.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/include/ipc/udp.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libinet
+/** @addtogroup libcipc
  * @{
  */
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBINET_IPC_UDP_H
-#define LIBINET_IPC_UDP_H
+#ifndef _LIBC_IPC_UDP_H_
+#define _LIBC_IPC_UDP_H_
 
 #include <ipc/common.h>
Index: uspace/lib/inet/include/types/inet.h
===================================================================
--- uspace/lib/inet/include/types/inet.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/include/types/inet.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libinet
+/** @addtogroup libc
  * @{
  */
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBINET_TYPES_INET_H
-#define LIBINET_TYPES_INET_H
+#ifndef _LIBC_TYPES_INET_H_
+#define _LIBC_TYPES_INET_H_
 
 #include <inet/addr.h>
Index: uspace/lib/inet/include/types/inet/host.h
===================================================================
--- uspace/lib/inet/include/types/inet/host.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/include/types/inet/host.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libinet
+/** @addtogroup libc
  * @{
  */
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBINETTYPES_INET_HOST_H
-#define LIBINETTYPES_INET_HOST_H
+#ifndef _LIBC_TYPES_INET_HOST_H_
+#define _LIBC_TYPES_INET_HOST_H_
 
 #include <inet/addr.h>
Index: uspace/lib/inet/include/types/inet/hostport.h
===================================================================
--- uspace/lib/inet/include/types/inet/hostport.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/include/types/inet/hostport.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libinet
+/** @addtogroup libc
  * @{
  */
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBINET_TYPES_INET_HOSTPORT_H
-#define LIBINET_TYPES_INET_HOSTPORT_H
+#ifndef _LIBC_TYPES_INET_HOSTPORT_H_
+#define _LIBC_TYPES_INET_HOSTPORT_H_
 
 #include <inet/addr.h>
Index: uspace/lib/inet/include/types/inetcfg.h
===================================================================
--- uspace/lib/inet/include/types/inetcfg.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/include/types/inetcfg.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2013 Jiri Svoboda
  * All rights reserved.
  *
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libinet
+/** @addtogroup libc
  * @{
  */
@@ -33,8 +33,7 @@
  */
 
-#ifndef LIBINET_TYPES_INETCFG_H
-#define LIBINET_TYPES_INETCFG_H
+#ifndef _LIBC_TYPES_INETCFG_H_
+#define _LIBC_TYPES_INETCFG_H_
 
-#include <inet/eth_addr.h>
 #include <inet/inet.h>
 #include <stddef.h>
@@ -57,5 +56,5 @@
 	size_t def_mtu;
 	/** Link layer address */
-	eth_addr_t mac_addr;
+	addr48_t mac_addr;
 } inet_link_info_t;
 
Index: uspace/lib/inet/include/types/inetping.h
===================================================================
--- uspace/lib/inet/include/types/inetping.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/include/types/inetping.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libinet
+/** @addtogroup libc
  * @{
  */
@@ -35,6 +35,6 @@
  */
 
-#ifndef LIBINET_TYPES_INETPING_H
-#define LIBINET_TYPES_INETPING_H
+#ifndef _LIBC_TYPES_INETPING_H_
+#define _LIBC_TYPES_INETPING_H_
 
 #include <inet/addr.h>
Index: uspace/lib/inet/meson.build
===================================================================
--- uspace/lib/inet/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/meson.build	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -32,5 +32,4 @@
 	'src/dnsr.c',
 	'src/endpoint.c',
-	'src/eth_addr.c',
 	'src/host.c',
 	'src/hostname.c',
@@ -44,7 +43,2 @@
 	'src/udp.c',
 )
-
-test_src = files(
-	'test/eth_addr.c',
-	'test/main.c',
-)
Index: uspace/lib/inet/src/addr.c
===================================================================
--- uspace/lib/inet/src/addr.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/src/addr.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2013 Jiri Svoboda
  * Copyright (c) 2013 Martin Decky
  * All rights reserved.
@@ -28,5 +28,5 @@
  */
 
-/** @addtogroup libinet
+/** @addtogroup libc
  * @{
  */
@@ -37,5 +37,4 @@
 #include <errno.h>
 #include <inet/addr.h>
-#include <inet/eth_addr.h>
 #include <stdio.h>
 #include <stddef.h>
@@ -55,6 +54,11 @@
 const addr32_t addr32_broadcast_all_hosts = 0xffffffff;
 
-static eth_addr_t inet_eth_addr_solicited_node =
-    ETH_ADDR_INITIALIZER(0x33, 0x33, 0xff, 0, 0, 0);
+const addr48_t addr48_broadcast = {
+	0xff, 0xff, 0xff, 0xff, 0xff, 0xff
+};
+
+static const addr48_t inet_addr48_solicited_node = {
+	0x33, 0x33, 0xff, 0, 0, 0
+};
 
 static const inet_addr_t inet_addr_any_addr = {
@@ -68,7 +72,21 @@
 };
 
+void addr48(const addr48_t src, addr48_t dst)
+{
+	memcpy(dst, src, 6);
+}
+
 void addr128(const addr128_t src, addr128_t dst)
 {
 	memcpy(dst, src, 16);
+}
+
+/** Compare addr48.
+ *
+ * @return Non-zero if equal, zero if not equal.
+ */
+int addr48_compare(const addr48_t a, const addr48_t b)
+{
+	return memcmp(a, b, 6) == 0;
 }
 
@@ -88,12 +106,8 @@
  *
  */
-void eth_addr_solicited_node(const addr128_t ip, eth_addr_t *mac)
-{
-	uint8_t b[6];
-	mac->a = inet_eth_addr_solicited_node.a;
-
-	eth_addr_encode(&inet_eth_addr_solicited_node, b);
-	memcpy(&b[3], ip + 13, 3);
-	eth_addr_decode(b, mac);
+void addr48_solicited_node(const addr128_t ip, addr48_t mac)
+{
+	memcpy(mac, inet_addr48_solicited_node, 3);
+	memcpy(mac + 3, ip + 13, 3);
 }
 
Index: uspace/lib/inet/src/dhcp.c
===================================================================
--- uspace/lib/inet/src/dhcp.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/src/dhcp.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libinet
+/** @addtogroup libc
  * @{
  */
Index: uspace/lib/inet/src/endpoint.c
===================================================================
--- uspace/lib/inet/src/endpoint.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/src/endpoint.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libinet
+/** @addtogroup libc
  * @{
  */
Index: uspace/lib/inet/src/host.c
===================================================================
--- uspace/lib/inet/src/host.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/src/host.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libinet
+/** @addtogroup libc
  * @{
  */
Index: uspace/lib/inet/src/hostname.c
===================================================================
--- uspace/lib/inet/src/hostname.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/src/hostname.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libinet
+/** @addtogroup libc
  * @{
  */
Index: uspace/lib/inet/src/hostport.c
===================================================================
--- uspace/lib/inet/src/hostport.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/src/hostport.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libinet
+/** @addtogroup libc
  * @{
  */
Index: uspace/lib/inet/src/inetcfg.c
===================================================================
--- uspace/lib/inet/src/inetcfg.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/src/inetcfg.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2012 Jiri Svoboda
  * All rights reserved.
  *
@@ -30,5 +30,4 @@
 #include <assert.h>
 #include <errno.h>
-#include <inet/eth_addr.h>
 #include <inet/inetcfg.h>
 #include <ipc/inet.h>
@@ -293,5 +292,5 @@
 	aid_t req = async_send_1(exch, INETCFG_LINK_GET, link_id, &answer);
 	aid_t dreq = async_data_read(exch, name_buf, LOC_NAME_MAXLEN, &dreply);
-	errno_t rc = async_data_read_start(exch, &linfo->mac_addr, sizeof(eth_addr_t));
+	errno_t rc = async_data_read_start(exch, &linfo->mac_addr, sizeof(addr48_t));
 	async_wait_for(dreq, &dretval);
 
